"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _events = require("events");

var _yargsParser = require("yargs-parser");

var _yargsParser2 = _interopRequireDefault(_yargsParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isArray = Array.isArray;
var entries = Object.entries;


var commandRegex = /\.*[\][<>]/g;
var useInit = {
  CLI: {
    options: {
      v: {
        alias: "version",
        desc: "version"
      },
      h: {
        alias: "help",
        decs: "help"
      }
    },
    commands: {
      "*": function _(_ref) {
        var v = _ref.v,
            h = _ref.h,
            CLI = _ref.CLI,
            _ref$CLI$config = _ref.CLI.config,
            version = _ref$CLI$config.version,
            help = _ref$CLI$config.help;

        v && console.log(version);
        h && console.log(typeof help === "function" ? help(CLI) : help);
      }
    }
  }
};

exports.default = {
  name: "CLI",
  Event: new _events.EventEmitter(),
  options: {},
  args: {},
  commands: {},
  config: {},
  _hooks: {
    CLI: {
      options: {
        _: function _(_ref2) {
          var _key = _ref2._key,
              _val = _ref2._val,
              cp = _ref2.cp;

          Object.assign(this.options, _val);
        }
      },
      commands: {
        $: function $(_ref3) {
          var _key = _ref3._key,
              _val = _ref3._val,
              cp = _ref3.cp;

          // const { exec, ...other } = _val;
          if (commandRegex.test(_key)) {
            var _key$replace$split = _key.replace(commandRegex, "").split(" "),
                _key$replace$split2 = (0, _toArray3.default)(_key$replace$split),
                command = _key$replace$split2[0],
                other = _key$replace$split2.slice(1);

            this.commands[command] = {
              args: other
            };
            this.Event.on(command, _val);
          } else {
            this.Event.on(_key, _val);
          }
        }
      },
      config: {
        _: function _(_ref4) {
          var _this = this;

          var _ = _ref4._,
              _val = _ref4._val;
          var start = _val.start,
              target = _val.target,
              _val$init = _val.init,
              init = _val$init === undefined ? true : _val$init;

          Object.assign(this.config, _val);

          if (init) {
            _.$use(useInit);
          }

          if (start) {
            var _parser = (0, _yargsParser2.default)(target || process.argv.slice(2)),
                __ = _parser._,
                options = (0, _objectWithoutProperties3.default)(_parser, ["_"]);

            var _2 = (0, _toArray3.default)(__),
                _$ = _2[0],
                _key = _$ === undefined ? "*" : _$,
                _args = _2.slice(1);

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
              for (var _iterator = entries(options)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var _ref5 = _step.value;

                var _ref6 = (0, _slicedToArray3.default)(_ref5, 2);

                var key = _ref6[0];
                var val = _ref6[1];

                this.args[key] = val;

                var _ref8 = this.options[key] || {},
                    alias = _ref8.alias;

                if (alias) {
                  this.args[alias] = val;
                }
              }
            } catch (err) {
              _didIteratorError = true;
              _iteratorError = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }
              } finally {
                if (_didIteratorError) {
                  throw _iteratorError;
                }
              }
            }

            var _ref7 = this.commands[_key] || {},
                _ref7$args = _ref7.args,
                args = _ref7$args === undefined ? [] : _ref7$args;

            args.forEach(function (argv, i) {
              _this.args[argv] = _args[i];
            });
            this.Event.emit(_key, (0, _extends3.default)({
              CLI: this
            }, this.args));
          }
        }
      }
    }
  }
};